xquery version "3.1";

module namespace t="http://ahikar.sub.uni-goettingen.de/ns/motifs-expansion/tests";

declare namespace tei="http://www.tei-c.org/ns/1.0";

import module namespace functx="http://www.functx.com" at "/db/system/repo/functx-1.0.1/functx/functx.xq";
import module namespace me="http://ahikar.sub.uni-goettingen.de/ns/motifs-expansion" at "../modules/motifs-expansion.xqm";
import module namespace test="http://exist-db.org/xquery/xqsuite" at "resource:org/exist/xquery/lib/xqsuite/xqsuite.xql";

declare
    %test:assertTrue
function t:simple-annotations-one-line() {
    let $result := t:get-test-data-simple-annotations-one-line()
        => me:main()
        => local:prepare-for-comparison()
    let $reference := t:get-goal-data-simple-annotations-one-line()
        => local:prepare-for-comparison()
    return
        $result = $reference
};

declare
    %test:assertTrue
function t:simple-annotations-two-lines() {
    let $result := t:get-test-data-simple-annotations-two-lines()
        => me:main()
        => local:prepare-for-comparison()
    let $reference := t:get-goal-data-simple-annotations-two-lines()
        => local:prepare-for-comparison()
    return
        $result = $reference
};

declare
    %test:assertTrue
function t:simple-annotations-multiple-lines() {
    let $result := t:get-test-data-simple-annotations-multiple-lines()
        => me:main()
        => local:prepare-for-comparison()
    let $reference := t:get-goal-data-simple-annotations-multiple-lines()
        => local:prepare-for-comparison()
    return
        $result = $reference
};

declare
    %test:assertTrue
function t:nested-annotations-multiple-lines() {
    let $result := t:get-test-data-nested-annotations()
        => me:main()
        => local:prepare-for-comparison()
    let $reference := t:get-goal-data-nested-annotations()
        => local:prepare-for-comparison()
    return
        $result = $reference
};

declare
    %test:assertTrue
function t:is-node-in-motif-true() {
    let $preprocessed := t:get-test-data-simple-annotations-one-line()
        => me:transform-pis()
    let $node := $preprocessed//tei:persName
    return
        me:is-node-in-motif($node)
};

declare
    %test:assertTrue
function t:is-node-in-motif-true-ab() {
    let $preprocessed := t:get-test-data-simple-annotations-multiple-lines()
        => me:transform-pis()
    let $node := $preprocessed//tei:ab[3]
    return
        me:is-node-in-motif($node)
};

declare
    %test:assertFalse
function t:is-node-in-motif-false-1() {
    let $node := t:get-test-data-simple-annotations-one-line()//tei:milestone
    return
        me:is-node-in-motif($node)
};

declare
    %test:assertFalse
function t:is-node-in-motif-false-2() {
    let $node := t:get-test-data-simple-annotations-two-lines()//tei:ab[4]/text()[last()]
    return
        me:is-node-in-motif($node)
};

declare
    %test:assertFalse
function t:is-node-in-motif-false-ab() {
    let $node := t:get-test-data-simple-annotations-multiple-lines()//tei:ab[2]
    return
        me:is-node-in-motif($node)
};

declare
    %test:assertTrue
function t:is-motif-one-liner-true() {
    let $preprocessed := 
        t:get-test-data-simple-annotations-one-line() 
        => me:transform-pis()
    let $node := $preprocessed//tei:motif[@type = "start"]
    return
        me:is-motif-one-liner($node)
};

declare
    %test:assertFalse
function t:is-motif-one-liner-false() {
    let $preprocessed := t:get-test-data-simple-annotations-two-lines()
        => me:transform-pis()
    let $node := $preprocessed//tei:motif[@type = "start"]
    return
        me:is-motif-one-liner($node)
};

declare
    %test:assertTrue
function t:is-inner-motif-of-nested-motif-true() {
    let $preprocessed := t:get-test-data-nested-annotations()
        => me:transform-pis()
    let $node := $preprocessed//tei:motif[@type = "start"][2]
    return
        me:is-inner-motif-of-nested-motif($node)
};

declare
    %test:assertFalse
function t:is-inner-motif-of-nested-motif-false() {
    let $preprocessed := t:get-test-data-simple-annotations-one-line()
        => me:transform-pis()
    let $node := $preprocessed//tei:motif[@type = "start"]
    return
        me:is-inner-motif-of-nested-motif($node)
};

declare
    %test:assertTrue
function t:is-first-motif-of-nested-motifs-true() {
    let $preprocessed := t:get-test-data-nested-annotations()
        => me:transform-pis()
    let $node := $preprocessed//tei:motif[@type = "start"][1]
    return
        me:is-first-motif-of-nested-motifs($node)
};

declare
    %test:assertFalse
function t:is-first-motif-of-nested-motifs-false() {
    let $preprocessed := t:get-test-data-simple-annotations-one-line()
        => me:transform-pis()
    let $node := $preprocessed//tei:motif[@type = "start"]
    return
        me:is-first-motif-of-nested-motifs($node)
};

declare
    %test:assertTrue
function t:is-last-motif-of-nested-motifs-true() {
    let $preprocessed := t:get-test-data-nested-annotations()
        => me:transform-pis()
    let $node := $preprocessed//tei:motif[@type = "start"][3]
    return
        me:is-last-motif-of-nested-motifs($node)
};

declare
    %test:assertFalse
function t:is-last-motif-of-nested-motifs-false() {
    let $preprocessed := t:get-test-data-nested-annotations()
        => me:transform-pis()
    let $node := $preprocessed//tei:motif[@type = "start"][2]
    return
        me:is-last-motif-of-nested-motifs($node)
};

declare
    %test:assertTrue
function t:is-node-in-nested-motif-true() {
    let $preprocessed := t:get-test-data-nested-annotations()
        => me:transform-pis()
    let $node := $preprocessed//tei:ab[2]
    return
        me:is-node-in-nested-motif($node)
};

declare
    %test:assertFalse
function t:is-node-in-nested-motif-false() {
    let $node := t:get-test-data-nested-annotations()//tei:ab[last()]
    return
        me:is-node-in-nested-motif($node)
};

declare
    %test:assertEquals("3")
function t:get-nested-motif-starts() {
    let $preprocessed := t:get-test-data-nested-annotations()
        => me:transform-pis()
    let $node := $preprocessed//tei:motif[@type = "start"][last()]
    return
        count(me:get-nested-motif-starts($node, ()))
};

declare
    %test:assertTrue
function t:is-first-motif-end-of-nested-motifs-true() {
    let $preprocessed := t:get-test-data-nested-annotations()
        => me:transform-pis()
    let $node := $preprocessed//tei:motif[@type = "end"][1]
    return
        me:is-first-motif-end-of-nested-motifs($node)
};

declare
    %test:assertFalse
function t:is-first-motif-end-of-nested-motifs-false() {
    let $preprocessed := t:get-test-data-nested-annotations()
        => me:transform-pis()
    let $node := $preprocessed/descendant::tei:motif[@type = "end"][last()]
    return
        me:is-first-motif-end-of-nested-motifs($node)
};

declare
    %test:assertTrue
function t:is-last-motif-end-of-nested-motifs-true() {
    let $preprocessed := t:get-test-data-nested-annotations()
        => me:transform-pis()
    let $node := $preprocessed/descendant::tei:motif[@type = "end"][last()]
    return
        me:is-last-motif-end-of-nested-motifs($node)
};

declare
    %test:assertFalse
function t:is-last-motif-end-of-nested-motifs-false() {
        let $preprocessed := t:get-test-data-nested-annotations()
        => me:transform-pis()
    let $node := $preprocessed/descendant::tei:motif[@type = "end"][1]
    return
        me:is-last-motif-end-of-nested-motifs($node)
};

declare
    %test:assertTrue
function t:is-inner-motif-end-of-nested-motifs-true() {
        let $preprocessed := t:get-test-data-nested-annotations()
        => me:transform-pis()
    let $node := $preprocessed/descendant::tei:motif[@type = "end"][2]
    return
        me:is-inner-motif-end-of-nested-motifs($node)
};

declare
    %test:assertFalse
function t:is-inner-motif-end-of-nested-motifs-false() {
    let $preprocessed := t:get-test-data-nested-annotations()
        => me:transform-pis()
    let $node := $preprocessed/descendant::tei:motif[@type = "end"][1]
    return
        me:is-inner-motif-end-of-nested-motifs($node)
};

declare
    %test:assertEquals("loyal_obligation_gods")
function t:get-previous-motif-start-simple() {
    let $node := t:get-test-data-simple-annotations-multiple-lines()//tei:ab[3]
    return
        $node/preceding::processing-instruction("oxy_comment_start")[substring-after(., "mid=""") => substring-before("""") = ""]
        => me:get-motif-type()
};

declare
    %test:assertEquals("self_examination_reflection")
function t:get-previous-motif-start-nested-no-mid() {
    let $node := t:get-test-data-nested-annotations()//tei:ab[2]
    return
        $node/preceding::processing-instruction("oxy_comment_start")[substring-after(., "mid=""") => substring-before("""") = ""]
        => me:get-motif-type()
};

declare
    %test:assertEquals("meekness_showing_respect")
function t:get-previous-motif-start-nested-mid() {
    let $node := t:get-test-data-nested-annotations()//tei:ab[2]
    return
        $node/preceding::processing-instruction("oxy_comment_start")[substring-after(., "mid=""") => substring-before("""") = "87"]
        => me:get-motif-type()
};

declare function t:get-test-data-simple-annotations-one-line()
as element(tei:TEI) {
    <TEI xmlns="http://www.tei-c.org/ns/1.0">
        <text>
            <group>
                <text xml:lang="ara" type="transliteration">
                    <body>
                        <milestone unit="first_narrative_section"/>
                        <pb n="293r"/>
                        <cb n="2"/>
                        <ab>نبتدي بعون الله ونكتب</ab>
                        <ab>قصة <?oxy_comment_start author="aelrefa" timestamp="20200827T090537+0200" comment="loyal_obligation_gods"?><persName>حيقار</persName> الحاكيم وكان فى<?oxy_comment_end?></ab>
                    </body>
                </text>
            </group>
        </text>
    </TEI>
};

declare function t:get-goal-data-simple-annotations-one-line()
as element(tei:TEI) {
    <TEI xmlns="http://www.tei-c.org/ns/1.0">
        <text>
            <group>
                <text xml:lang="ara" type="transliteration">
                    <body>
                        <milestone unit="first_narrative_section"/>
                        <pb n="293r"/>
                        <cb n="2"/>
                        <ab>نبتدي بعون الله ونكتب</ab>
                        <ab>قصة <span type="motif" n="loyal_obligation_gods"><persName>حيقار</persName> الحاكيم وكان فى</span></ab>
                    </body>
                </text>
            </group>
        </text>
    </TEI>
};

declare function t:get-test-data-simple-annotations-two-lines()
as element(tei:TEI) {
    <TEI xmlns="http://www.tei-c.org/ns/1.0">
        <text>
            <group>
                <text xml:lang="ara" type="transliteration">
                    <body>
                        <milestone unit="first_narrative_section"/>
                        <pb n="293r"/>
                        <cb n="2"/>
                        <ab>نبتدي بعون الله ونكتب</ab>
                        <ab>قصة <?oxy_comment_start author="aelrefa" timestamp="20200827T090537+0200" comment="loyal_obligation_gods"?><persName>حيقار</persName> الحاكيم وكان فى</ab>
                        <ab>للالهة<?oxy_comment_end?> وقلتوا لهم ارزقونى</ab>
                    </body>
                </text>
            </group>
        </text>
    </TEI>
};

declare function t:get-goal-data-simple-annotations-two-lines()
as element(tei:TEI) {
    <TEI xmlns="http://www.tei-c.org/ns/1.0">
        <text>
            <group>
                <text xml:lang="ara" type="transliteration">
                    <body>
                        <milestone unit="first_narrative_section"/>
                        <pb n="293r"/>
                        <cb n="2"/>
                        <ab>نبتدي بعون الله ونكتب</ab>
                        <ab>قصة <span id="N1.1.1.1.3.5.2-1" type="motif" n="loyal_obligation_gods" next="#N1.1.1.1.3.5.2-2"><persName>حيقار</persName> الحاكيم وكان فى</span></ab>
                        <ab><span id="N1.1.1.1.3.5.2-2" type="motif" n ="loyal_obligation_gods">للالهة</span> وقلتوا لهم ارزقونى</ab>
                    </body>
                </text>
            </group>
        </text>
    </TEI>
};

declare function t:get-test-data-simple-annotations-multiple-lines()
as element(tei:TEI) {
    <TEI xmlns="http://www.tei-c.org/ns/1.0">
        <text>
            <group>
                <text xml:lang="ara" type="transliteration">
                    <body>
                        <milestone unit="first_narrative_section"/>
                        <pb n="293r"/>
                        <cb n="2"/>
                        <ab>نبتدي بعون الله ونكتب</ab>
                        <ab>قصة <?oxy_comment_start author="aelrefa" timestamp="20200827T090537+0200" comment="loyal_obligation_gods"?><persName>حيقار</persName> الحاكيم وكان فى</ab>
                        <ab>يدفني ولم يجيبوه الالهة.</ab>
                        <ab>للالهة<?oxy_comment_end?> وقلتوا لهم ارزقونى</ab>
                    </body>
                </text>
            </group>
        </text>
    </TEI>
};

declare function t:get-goal-data-simple-annotations-multiple-lines()
as element(tei:TEI) {
    <TEI xmlns="http://www.tei-c.org/ns/1.0">
        <text>
            <group>
                <text xml:lang="ara" type="transliteration">
                    <body>
                        <milestone unit="first_narrative_section"/>
                        <pb n="293r"/>
                        <cb n="2"/>
                        <ab>نبتدي بعون الله ونكتب</ab>
                        <ab>قصة <span id="N1.1.1.1.3.5.2-1" type="motif" n="loyal_obligation_gods" next="#N1.1.1.1.3.5.2-2"><persName>حيقار</persName> الحاكيم وكان فى</span></ab>
                        <ab><span id="N1.1.1.1.3.5.2-2" type="motif" n ="loyal_obligation_gods" next="#N1.1.1.1.3.5.2-3">يدفني ولم يجيبوه الالهة.</span></ab>
                        <ab><span id="N1.1.1.1.3.5.2-3" type="motif" n ="loyal_obligation_gods">للالهة</span> وقلتوا لهم ارزقونى</ab>
                    </body>
                </text>
            </group>
        </text>
    </TEI>
};

declare function t:get-test-data-nested-annotations()
as element(tei:TEI) {
    <TEI xmlns="http://www.tei-c.org/ns/1.0">
        <text>
            <group>
                <text xml:lang="ara" type="transliteration">
                    <body>
                        <ab><?oxy_comment_start author="simon" timestamp="20201106T141533+0100" comment="self_examination_reflection"?><?oxy_comment_start author="simon" timestamp="20201106T141541+0100" comment="meekness_showing_respect" mid="87"?><?oxy_comment_start author="simon" timestamp="20210320T162517+0100" comment="social_contacts_no_family" mid="88"?>ܒܸܪܝ
                          ܠܵܐ ܬܸܐܡܲܪ ܕܡܵܪܝ ܠܸܠܵܐ܂ ܘܐܸܢܐ ܚܲܟܿܝܼܡܵܐ܂</ab>
                        <ab>ܐܸܠܵܐ ܘܵܠܸܐ ܕܢܸܗܘܸܐ ܠܘܵܬܼܟ ܡܝܲܬܪܐ܂ܐܵܦܼܢ</ab>
                        <ab>ܒܗܵܕܸܐ ܨܘܼܪܬܿܐ܂<?oxy_comment_end?><?oxy_comment_end mid="87"?><?oxy_comment_end mid="88"?> ܒܸܪܝ ܠܵܐ ܬܿܘܪܹܟ ܡܸ̈ܠܸ</ab>
                        <ab>جملة أخرى</ab>
                    </body>
                </text>
            </group>
        </text>
    </TEI>
};

declare function t:get-goal-data-nested-annotations()
as element(tei:TEI) {
    <TEI xmlns="http://www.tei-c.org/ns/1.0">
        <text>
            <group>
                <text xml:lang="ara" type="transliteration">
                    <body>
                        <ab>
                            <span id="N1.1.1.1.3.1.1-1" type="motif" n="self_examination_reflection" next="#N1.1.1.1.3.1.1-2">
                                <span id="N1.1.1.1.3.1.2-1" type="motif" n="meekness_showing_respect" next="#N1.1.1.1.3.1.2-2">
                                    <span id="N1.1.1.1.3.1.3-1" type="motif" n="social_contacts_no_family" next="#N1.1.1.1.3.1.3-2">ܒܸܪܝ
                                        ܠܵܐ ܬܸܐܡܲܪ ܕܡܵܪܝ ܠܸܠܵܐ܂ ܘܐܸܢܐ ܚܲܟܿܝܼܡܵܐ܂</span>
                                </span>
                            </span>
                        </ab>
                        <ab>
                            <span id="N1.1.1.1.3.1.1-2" type="motif" n="self_examination_reflection" next="#N1.1.1.1.3.1.1-3">
                                <span id="N1.1.1.1.3.1.2-2" type="motif" n="meekness_showing_respect" next="#N1.1.1.1.3.1.2-3">
                                    <span id="N1.1.1.1.3.1.3-2" type="motif" n="social_contacts_no_family" next="#N1.1.1.1.3.1.3-3">ܐܸܠܵܐ ܘܵܠܸܐ ܕܢܸܗܘܸܐ ܠܘܵܬܼܟ ܡܝܲܬܪܐ܂ܐܵܦܼܢ</span>
                                </span>
                            </span>
                        </ab>
                        <ab>
                            <span id="N1.1.1.1.3.1.1-3" type="motif" n="self_examination_reflection">
                                <span id="N1.1.1.1.3.1.2-3" type="motif" n="meekness_showing_respect">
                                    <span id="N1.1.1.1.3.1.3-3" type="motif" n="social_contacts_no_family">ܒܗܵܕܸܐ ܨܘܼܪܬܿܐ܂</span>
                                </span>
                            </span> ܒܸܪܝ ܠܵܐ ܬܿܘܪܹܟ ܡܸ̈ܠܸ</ab>
                        <ab>جملة أخرى</ab>
                    </body>
                </text>
            </group>
        </text>
    </TEI>
};

declare
    %test:assertTrue
function t:simple-annotations-one-line() {
    let $result := t:get-test-data-simple-annotations-two-lines()
        => me:main()
        => local:prepare-for-comparison()
    let $reference := t:get-goal-data-simple-annotations-two-lines()
        => local:prepare-for-comparison()
    return
        $result = $reference
};

declare
    %test:assertTrue
function t:ssimple-several-lines-damage() {
    let $result := t:get-test-data-simple-several-lines-damage()
        => me:main()
        => local:prepare-for-comparison()
    let $reference := t:get-goal-data-simple-several-lines-damage()
        => local:prepare-for-comparison()
    return
        $result = $reference
};

declare
    %test:assertTrue
function t:quote() {
    let $result := t:get-test-data-quote()
        => me:main()
        => local:prepare-for-comparison()
    let $reference := t:get-goal-data-quote()
        => local:prepare-for-comparison()
    return
        $result = $reference
};

declare
    %test:assertTrue
function t:sort-motifs-into-lines() {
    let $result := t:get-test-data-sort-motifs-into-lines()
        => me:main()
        => local:prepare-for-comparison()
    let $reference := t:get-goal-data-sort-motifs-into-lines()
        => local:prepare-for-comparison()
    return
        $result = $reference
};

declare
    %test:assertTrue
function t:is-node-in-motif-true-2() {
    let $node := t:get-test-data-nested-several-lines()/descendant::tei:quote[last()]
    return
        me:is-node-in-motif($node)
};

declare
    %test:assertFalse
function t:is-node-in-motif-false-1() {
    let $node := t:get-test-data-simple-annotations-two-lines()//tei:ab[1]
    return
        me:is-node-in-motif($node)
};

declare
    %test:assertEquals("loyal_obligation_gods")
function t:get-previous-motif-start() {
    let $preprocessed := t:get-test-data-simple-annotations-two-lines() => me:transform-pis()
    let $node := $preprocessed//tei:ab[3]
    return
        me:get-previous-motif-start($node, ())/@n/string()
};

declare function t:get-test-data-simple-annotations-two-lines() {
    <TEI xmlns="http://www.tei-c.org/ns/1.0">
        <text>  
            <group>
                <text type="transcription" xml:lang="syc">
                    <body>
                        <ab> ܘܒܪܐ ܠܐ ܗܘܼܐ ܠܝ <add place="above">ܡܢ ܚܕܐ</add> ܡܢܗܝܢ܂ ܘܗܝܕܝܢ </ab>
                        <ab>ܒܢܝܿܬܼ ܠܝ ܥܠܬܼܐ ܚܕܐ ܪܒܬܼܐ܂
                            <motif type="start" n="loyal_obligation_gods"/>ܘܣܿܡܬܼ</ab>
                        <ab>ܥܠܝܗ ܨܘܪܐ ܛܒܐ܂ ܘܐܣܩܿܬܼ ܕܒܚ̈ܐ</ab>
                        <ab>ܠܡܪܝܐ܂<motif type="end"/> ܘܐܡܿܪܬ܂ ܐܝܢ ܡܪܝܐ ܐܠܗܐ</ab>
                        <ab>ܢܗܘܐ ܠܝ ܒܪܐ܂ ܕܐܡܬܝ ܕܡܵܝܸܬܼ ܐܢܐ ܢܗܼܘܐ</ab>
                    </body>
                </text>
            </group>
        </text>
    </TEI>
};

declare function t:get-goal-data-simple-annotations-two-lines() {
    <TEI xmlns="http://www.tei-c.org/ns/1.0">
        <text>
            <group>
                <text type="transcription" xml:lang="syc">
                    <body>
                        <ab> ܘܒܪܐ ܠܐ ܗܘܼܐ ܠܝ <add place="above">ܡܢ ܚܕܐ</add> ܡܢܗܝܢ܂ ܘܗܝܕܝܢ </ab>
                        <ab>ܒܢܝܿܬܼ ܠܝ ܥܠܬܼܐ ܚܕܐ ܪܒܬܼܐ܂
                            <span id="N1.1.1.1.3.2.2-1" type="motif" n="loyal_obligation_gods" next="#N1.1.1.1.3.2.2-2">ܘܣܿܡܬܼ</span>
                        </ab>
                        <ab>
                            <span id="N1.1.1.1.3.2.2-2" type="motif" n="loyal_obligation_gods" next="#N1.1.1.1.3.2.2-3">ܥܠܝܗ ܨܘܪܐ ܛܒܐ܂ ܘܐܣܩܿܬܼ ܕܒܚ̈ܐ</span>
                        </ab>
                        <ab><span id="N1.1.1.1.3.2.2-3" type="motif" n="loyal_obligation_gods">ܠܡܪܝܐ܂</span> ܘܐܡܿܪܬ܂ ܐܝܢ ܡܪܝܐ ܐܠܗܐ</ab>
                        <ab>ܢܗܘܐ ܠܝ ܒܪܐ܂ ܕܐܡܬܝ ܕܡܵܝܸܬܼ ܐܢܐ ܢܗܼܘܐ</ab>
                    </body>
                </text>
            </group>
        </text>
    </TEI>
};

declare function t:get-test-data-simple-several-lines-damage() {
    <TEI xmlns="http://www.tei-c.org/ns/1.0">
        <text>  
            <group>
                <text type="transcription" xml:lang="syc">
                    <body>
                       <ab>ܥܒܕܝܗܝ ܠܟ ܒܪܐ܂
                          <motif type="start" n="loyal_obligation_gods"/>ܟܕ
                          ܗܠܝܢ ܫܡܿܥܬܼ</ab>
                       <ab> ܦܘܩܕܢܐ ܥܒܿܕܬܼ܂ ܘܢܿܣܒܬ <persName>ܠܢܕܢ</persName> ܒܪ </ab>
                       <ab>
                          <damage>ܚܵܬܝ܂<motif type="end"/>
                                </damage> ܐܫܠܡܬܗ ܠܡܝ̈ܩܢܬܐ ܬܡ̈ܢܐ܂ </ab>
                    </body>
                </text>
            </group>
        </text>
    </TEI>
};

declare function t:get-goal-data-simple-several-lines-damage() {
    <TEI xmlns="http://www.tei-c.org/ns/1.0">
        <text>
            <group>
                <text type="transcription" xml:lang="syc">
                    <body>
                        <ab>ܥܒܕܝܗܝ ܠܟ ܒܪܐ܂
                          <span id="N1.1.1.1.3.1.2-1" type="motif" n="loyal_obligation_gods" next="#N1.1.1.1.3.1.2-2">ܟܕ
                          ܗܠܝܢ ܫܡܿܥܬܼ</span>
                        </ab>
                        <ab>
                            <span id="N1.1.1.1.3.1.2-2" type="motif" n="loyal_obligation_gods" next="#N1.1.1.1.3.1.2-3"> ܦܘܩܕܢܐ ܥܒܿܕܬܼ܂ ܘܢܿܣܒܬ <persName>ܠܢܕܢ</persName> ܒܪ </span>
                        </ab>
                        <ab>
                            <damage>
                                <span id="N1.1.1.1.3.1.2-3" type="motif" n="loyal_obligation_gods">ܚܵܬܝ܂</span>
                            </damage> ܐܫܠܡܬܗ ܠܡܝ̈ܩܢܬܐ ܬܡ̈ܢܐ܂ </ab>
                    </body>
                </text>
            </group>
        </text>
    </TEI>
};

declare function t:get-test-data-nested-several-lines() {
    <TEI xmlns="http://www.tei-c.org/ns/1.0">
        <text>  
            <group>
                <text type="transcription" xml:lang="syc">
                    <body>
                   <ab>
                      <hi rend="color(dark red)"> ܝܘܠܦܢܐ ܕܐܠܦ <persName>ܠܢܕܢ</persName>
                      </hi>
                            <motif type="start" n="keeping_secrets"/>
                            <motif type="start" n="loyal_obligation_gods" mid="6"/>
                      <quote next="#say2.spr2">ܒܪܝ ܐܢ ܬܫܼܡܥ</quote>
                   </ab>
                   <ab>
                            <quote xml:id="say2.spr2">
                         <damage> ܡܠܬܐ܀ </damage> ܬܡܘܬܝܗ ܒܠܒܟ ܘܠܐܢܫ ܠܐ ܬܓܠܝܗܿ܁ </quote>
                        </ab>
                   <ab>
                            <quote xml:id="say2.1.spr2">
                         <damage>
                            <orig>ܠܡܐ</orig>
                            <supplied>ܕܠܡܐ</supplied>
                         </damage> ܬܗܘܐ ܓܡܘܪܬܐ ܒܦܘܡܟ ܘܬܟܘܝܟ܂ </quote>
                        </ab>
                   <ab>
                            <quote xml:id="say2.2.spr2"> ܘܡܘܡܐ ܬܣܝܼܡ ܒܓܘܫܡܟ܂ ܘܥܲܠ ܐܠܗܐ</quote>
                        </ab>
                   <ab>
                            <quote xml:id="say2.3.spr2">ܬܬܪܥܡ܀</quote>
                            <motif type="end"/>
                            <motif type="end" mid="6"/>
                      <motif type="start" n="keeping_secrets"/>
                      <quote next="#say3.spr3">ܒܪܝ ܟܠ ܕܚܿܙܐ ܐܢܬ ܠܐ ܬܓܠܐ܂</quote>
                      <motif type="end"/>
                        </ab>
                    </body>
                </text>
            </group>
        </text>
    </TEI>
};

declare function t:get-goal-data-nested-several-lines() {
    <TEI xmlns="http://www.tei-c.org/ns/1.0">
        <text>
            <group>
                <text type="transcription" xml:lang="syc">
                    <body>
                        <ab>
                            <hi rend="color(dark red)"> ܝܘܠܦܢܐ ܕܐܠܦ <persName>ܠܢܕܢ</persName>
                            </hi>
                            <span id="N1.1.1.1.3.1.2-1" type="motif" n="keeping_secrets" next="#N1.1.1.1.3.1.2-2">
                                <span id="N1.1.1.1.3.1.3-1" type="motif" n="loyal_obligation_gods" next="#N1.1.1.1.3.1.3-2">
                                    <quote next="#say2.spr2">ܒܪܝ ܐܢ ܬܫܼܡܥ</quote>
                                </span>
                            </span>
                        </ab>
                        <ab>
                            <span id="N1.1.1.1.3.1.2-2" type="motif" n="keeping_secrets" next="#N1.1.1.1.3.1.2-3">
                                <span id="N1.1.1.1.3.1.3-2" type="motif" n="loyal_obligation_gods" next="#N1.1.1.1.3.1.3-3">
                                    <quote xml:id="say2.spr2">
                                        <damage> ܡܠܬܐ܀ </damage> ܬܡܘܬܝܗ ܒܠܒܟ ܘܠܐܢܫ ܠܐ ܬܓܠܝܗܿ܁ </quote>
                                </span>
                            </span>
                        </ab>
                        <ab>
                            <span id="N1.1.1.1.3.1.2-3" type="motif" n="keeping_secrets" next="#N1.1.1.1.3.1.2-4">
                                <span id="N1.1.1.1.3.1.3-3" type="motif" n="loyal_obligation_gods" next="#N1.1.1.1.3.1.3-4">
                                    <quote xml:id="say2.1.spr2">
                                        <damage>
                                            <orig>ܠܡܐ</orig>
                                            <supplied>ܕܠܡܐ</supplied>
                                        </damage> ܬܗܘܐ ܓܡܘܪܬܐ ܒܦܘܡܟ ܘܬܟܘܝܟ܂ </quote>
                                </span>
                            </span>
                        </ab>
                        <ab>
                            <span id="N1.1.1.1.3.1.2-4" type="motif" n="keeping_secrets" next="#N1.1.1.1.3.1.2-5">
                                <span id="N1.1.1.1.3.1.3-4" type="motif" n="loyal_obligation_gods" next="#N1.1.1.1.3.1.3-5">
                                    <quote xml:id="say2.2.spr2"> ܘܡܘܡܐ ܬܣܝܼܡ ܒܓܘܫܡܟ܂ ܘܥܲܠ ܐܠܗܐ</quote>
                                </span>
                            </span>
                        </ab>
                        <ab>
                            <span id="N1.1.1.1.3.1.2-5" type="motif" n="keeping_secrets">
                                <span id="N1.1.1.1.3.1.3-5" type="motif" n="loyal_obligation_gods">
                                    <quote xml:id="say2.3.spr2">ܬܬܪܥܡ܀</quote>
                                </span>
                            </span>
                            <span type="motif" n="keeping_secrets">
                                <quote next="#say3.spr3">ܒܪܝ ܟܠ ܕܚܿܙܐ ܐܢܬ ܠܐ ܬܓܠܐ܂</quote>
                            </span>
                        </ab>
                    </body>
                </text>
            </group>
        </text>
    </TEI>
};

declare function t:get-test-data-quote() {
    <TEI xmlns="http://www.tei-c.org/ns/1.0">
        <text>
            <group>
                <text type="transcription" xml:lang="syc">
                    <body>
                       <ab><quote next="#prov1.prov1"
                             ><?oxy_comment_start author="simon" timestamp="20200827T120411+0200" comment="quarrel"?>Quote Teil 1</quote></ab>
                       <ab><quote xml:id="prov1.prov1">Quote Teil 2</quote><?oxy_comment_end?></ab>
                    </body>
                </text>
            </group>
        </text>
    </TEI>
};

declare function t:get-goal-data-quote() {
    <TEI xmlns="http://www.tei-c.org/ns/1.0">
        <text>
            <group>
                <text type="transcription" xml:lang="syc">
                    <body>
                        <ab>
                            <quote next="#prov1.prov1">
                                <span id="N1.1.1.1.3.1.1.2-1" type="motif" n="quarrel" next="#N1.1.1.1.3.1.1.2-2">Quote Teil 1</span>
                            </quote>
                        </ab>
                        <ab>
                            <span id="N1.1.1.1.3.1.1.2-2" type="motif" n="quarrel">
                                <quote xml:id="prov1.prov1">Quote Teil 2</quote>
                            </span>
                        </ab>
                    </body>
                </text>
            </group>
        </text>
    </TEI>
};

declare function t:get-test-data-sort-motifs-into-lines() {
    <TEI xmlns="http://www.tei-c.org/ns/1.0">
        <text>
            <group>
                <text type="transcription" xml:lang="syc">
                    <body>
                        <ab><motif n="test" type="start"/><motif n="test2" mid="2" type="start"/>lorem ipsum</ab>
                        <pb n="2"/>
                        <motif type="end" mid="2"/>
                        <motif type="end"/>
                        <motif n="test3" type="start"/>
                        <ab>dolor sit amet<motif type="end"/></ab>
                    </body>
                </text>
            </group>
        </text>
    </TEI>
};

declare function t:get-goal-data-sort-motifs-into-lines() {
    <TEI xmlns="http://www.tei-c.org/ns/1.0">
        <text>
            <group>
                <text type="transcription" xml:lang="syc">
                    <body>
                        <ab><span id="N1.1.1.1.3.1.1-1" type="motif" n="test">
                            <span id="N1.1.1.1.3.1.2-1" type="motif" n="test2">lorem ipsum</span>
                        </span></ab>
                        <pb n="2"/>
                        <ab><span type="motif" n="test3">dolor sit amet</span></ab>
                    </body>
                </text>
            </group>
        </text>
    </TEI>
};

declare function local:prepare-for-comparison($nodes as node())
as xs:string {
    serialize($nodes)
    => replace("[\t\r\n]", "")
    => replace("\s+", " ")
};
